using System;
using System.Drawing;
using System.Collections;
using System.Windows.Forms;
using System.Data;
using Tabdee.FormController;


namespace EmbeddedForms
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
        private System.Windows.Forms.MenuItem toolsMenuItem;
        private System.Windows.Forms.MenuItem showEmbeddedMenuItem;
        private System.Windows.Forms.MenuItem showNormalMenuItem;
        private System.Windows.Forms.MainMenu mainMenu;

		public Form1()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

            // Should normally implement these events too, to 
            // manage large amounts of resources that might be 
            // left hanging around
            this.Activated += new EventHandler(Form1_Activated);
            this.Deactivate += new EventHandler(Form1_Deactivate);
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			base.Dispose( disposing );
		}
		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
            this.mainMenu = new System.Windows.Forms.MainMenu();
            this.toolsMenuItem = new System.Windows.Forms.MenuItem();
            this.showEmbeddedMenuItem = new System.Windows.Forms.MenuItem();
            this.showNormalMenuItem = new System.Windows.Forms.MenuItem();
            // 
            // mainMenu
            // 
            this.mainMenu.MenuItems.Add(this.toolsMenuItem);
            // 
            // toolsMenuItem
            // 
            this.toolsMenuItem.MenuItems.Add(this.showEmbeddedMenuItem);
            this.toolsMenuItem.MenuItems.Add(this.showNormalMenuItem);
            this.toolsMenuItem.Text = "Tools";
            // 
            // showEmbeddedMenuItem
            // 
            this.showEmbeddedMenuItem.Text = "Show Embedded Form";
            this.showEmbeddedMenuItem.Click += new System.EventHandler(this.showEmbeddedMenuItem_Click);
            // 
            // showNormalMenuItem
            // 
            this.showNormalMenuItem.Text = "Show Normal Form";
            this.showNormalMenuItem.Click += new System.EventHandler(this.showNormalMenuItem_Click);
            // 
            // Form1
            // 
            this.Menu = this.mainMenu;
            this.Text = "Embedded Forms";
            this.Closing += new System.ComponentModel.CancelEventHandler(this.mainForm_Closing);
            this.Load += new System.EventHandler(this.mainForm_Load);

        }
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>

		static void Main() 
		{
			Application.Run(new Form1());
		}

        private void showEmbeddedMenuItem_Click(object sender, System.EventArgs e)
        {
            FormController.ShowMainEmbeddedForm();
        }

        private void showNormalMenuItem_Click(object sender, System.EventArgs e)
        {
            NormalForm normalForm = new NormalForm();
        
            normalForm.Show();
        }

        private void mainForm_Load(object sender, System.EventArgs e)
        {
            FormController.MainEmbeddedFormType = typeof(EmbeddedForm);
            FormController.MainForm = this;

            // Normally would leave the main form empty, without a menu, and just
            // embed the form that will act as the main form, as per the line below.
            // For this demo only there is a menu on Form1 to show normal form display
            // and the flickering it causes if MinimizeBox = false (to get an OK button showing)
            //FormController.ShowMainEmbeddedForm();
        }

        private void mainForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (!MinimizeBox) 
            {
                // Displaying something other than the main embedded form
                // so close that form, and go back to the main embedded
                // form.
                FormController.ShowMainEmbeddedForm();
                e.Cancel = true;
            }
        }

        private void Form1_Activated(object sender, EventArgs e)
        {
            // Do things like load up data here
        }

        private void Form1_Deactivate(object sender, EventArgs e)
        {
            // Free up data, etc here so other apps have more RAM 
        }
    }
}
